#|

Spans a collection of notes [*mynotes*] to the ranges specified by each voice

give pitch classes in list
give min and max range
Add all pitch classes by 1*12 2*12, etc to fill min maximum range
remove notes above max and below min
|#

(defun filter-out-below-range (a-list lowest-note) 
  (cond ((null a-list) ())
   ((>= (first a-list) lowest-note) (cons (first a-list)(filter-out-below-range (rest a-list) lowest-note)))
        (t (filter-out-below-range (rest a-list) lowest-note))))


;;yields maximum notes available spanning the range

(defun fit-to-range (pitch-classes lowest-note highest-note)
  (filter-out-below-range (make-max-range pitch-classes highest-note) lowest-note))


(defun make-max-range (pitch-classes highest-note &optional (accumulator 0)) 
  (if (> (first pitch-classes) highest-note) ()
    (if (> (first (last pitch-classes)) highest-note) (make-max-range (butlast pitch-classes) highest-note accumulator)
      (append pitch-classes (make-max-range (doit pitch-classes (* 12 (+ accumulator 1))) highest-note accumulator)))))






;yields maximum notes available as a complete scale spanning the range

(defun fit-to-range-complete (pitch-classes lowest-note highest-note)
  (filter-out-below-range (make-max-range-complete pitch-classes highest-note) lowest-note))

(defun make-max-range-complete (pitch-classes highest-note &optional (accumulator 0)) 
  (if (> (first (last pitch-classes)) highest-note) ()
    (append pitch-classes (make-max-range-complete (doit pitch-classes (* 12 (+ accumulator 1))) highest-note))))





;;pl is pitch list and acc is accumulator. This simple adder does the octave scaling

(defun doit (pl acc) 
  (if (null pl)()
    (cons (+ acc (first pl))
          (doit (rest pl) acc))))







